#ifndef __INC_HTTPResponse
#define __INC_HTTPResponse

#include "MGLinkedList.h"
#include "TextParser.h"

#include "HTTPBase.h"
#include "HTTPHeaders.h"

#define	rcContinue 100
#define	rcOK 200
#define	rcCreated 201
#define	rcAccepted 202
#define	rcNoContent 204
#define	rcMultiple 300
#define	rcMovedPermanently 301
#define	rcMovedTemporarily 302
#define	rcNotModified 304
#define	rcBadRequest 400
#define	rcUnauthorized 401
#define	rcForbidden 403
#define	rcNotFound 404
#define	rcInternalServerError 500
#define	rcNotImplemented 501
#define	rcBadGateway 502
#define	rcServiceUnavailable 503

class HTTPRequest;

class HTTPResponse : public HTTPBase
{
private:
	HTTPHeaders *m_headers;
	
	HTTPRequest	*m_request;

	TextParser 	*m_txtParser;

	CMKString m_HTTPVersion;
	CMKString m_content;

	void processStatusLine();
	//Funciones para el parseo del Status (primera linea de la respuesta)
	bool getResponseCode();
	bool getVersion();
	
	void processHeaders(); //Procesa todos los header agregandolos a m_headers
	void processHeader();  //Genera el par NAME: VALUE a ser agregado a m_headers
	void processContent(short size);
	void searchForCookies(); //Una vez parseado los headers, busca headers con el nombre SET-COOKIE
	
public:
	unsigned short responseCode;
		
	void setResponseBuffer(char* buffer);
	
	unsigned short processResponseHeader(char** buffer);
	unsigned short processResponseContent(char** buffer, short bufSize);

	void clearResponseObject();
	
	unsigned short getContentLength();
	char* getContent() { return m_content.value; }

	HTTPResponse(HTTPRequest* request);
	virtual ~HTTPResponse();
	
	HTTPHeaders *getHeaders() { return m_headers; }
	
};

#endif
