#ifndef __INC_MGSTREAM
#define __INC_MGSTREAM

#include "CMKStdLib.h"

class CMGStream
{
public:
	CMGStream(); 
	CMGStream(char* buffer, unsigned long size);
	virtual ~CMGStream();
	
	void reset();
	
	char* str();
	unsigned long pcount() const;
	unsigned long ppos() const;
	void freeze(bool frz=true);
	bool eof();
	

	void write(char *data, unsigned short size);
	void write(int data);
	void write(unsigned int data);
	void write(short data);
	void write(unsigned short data);
	void write(long data);
	void write(unsigned long data);
//	void write(bool data);
	void write(char data);
	void write(unsigned char data);
	void write(char *data);
	void write(bool data);
	void write(CMGStream &data);	
	

	void read(char *data, unsigned short size);
	void read(int &data);
	void read(unsigned int &data);
	void read(short &data);
	void read(unsigned short &data);
	void read(long &data);
	void read(unsigned long &data);
//	void read(bool data);
	void read(char &data);
	void read(unsigned char &data);	
	void read(char *data);
	void read(bool &data);
	void read(CMGStream &data);
		

	friend CMGStream& operator<< ( CMGStream& os, int  v) { os.write(v); return os;};
	friend CMGStream& operator>> ( CMGStream& os, int& v) { os.read(v); return os;};
	
	friend CMGStream& operator<< ( CMGStream& os, unsigned int  v) { os.write(v); return os;};
	friend CMGStream& operator>> ( CMGStream& os, unsigned int& v) { os.read(v); return os;};
	
	friend CMGStream& operator<< ( CMGStream& os, short  v) { os.write(v); return os;};
	friend CMGStream& operator>> ( CMGStream& os, short& v) { os.read(v); return os;};

	friend CMGStream& operator<< ( CMGStream& os, unsigned short  v) { os.write(v); return os;};
	friend CMGStream& operator>> ( CMGStream& os, unsigned short& v) { os.read(v); return os;};		

	friend CMGStream& operator<< ( CMGStream& os, long  v) { os.write(v); return os;}
	friend CMGStream& operator>> ( CMGStream& os, long& v) { os.read(v); return os;};

	friend CMGStream& operator<< ( CMGStream& os, unsigned long  v) { os.write(v); return os;};
	friend CMGStream& operator>> ( CMGStream& os, unsigned long& v) { os.read(v); return os;};

	friend CMGStream& operator<< ( CMGStream& os, char  v) { os.write(v); return os;};
	friend CMGStream& operator>> ( CMGStream& os, char& v) { os.read(v); return os;};
	
	friend CMGStream& operator<< ( CMGStream& os, unsigned char  v) { os.write(v); return os;};
	friend CMGStream& operator>> ( CMGStream& os, unsigned char& v) { os.read(v); return os;};


	friend CMGStream& operator<< ( CMGStream& os, char*  v) { os.write(v); return os;};
	friend CMGStream& operator>> ( CMGStream& os, char*  v) { os.read(v); return os;};			

	friend CMGStream& operator<< ( CMGStream& os, bool  v) { os.write(v); return os;};
	friend CMGStream& operator>> ( CMGStream& os, bool& v) { os.read(v); return os;};

	friend CMGStream& operator<< ( CMGStream& os, CMGStream&  v) { os.write(v); return os;};
	friend CMGStream& operator>> ( CMGStream& os, CMGStream& v) { os.read(v); return os;};	
	
protected:
	MemHandle m_memH;
	void* m_memP;
	unsigned long m_position;
	unsigned long m_allocSize;
	unsigned long m_size;
	
	bool m_owned;
	bool m_modifiable;
	bool m_extendable ;
	bool m_frozen;
	
	void* getOffSet();
	
	bool setNewSize(unsigned long newSize);
	unsigned long calculateNewSize(unsigned long newSize);
	unsigned short getNextSize();
	
	void createHandle(unsigned long size);
	bool resizeHandle(unsigned long newSize);
	void lockHandle();
	void unlockHandle();
	void freeHandle();
};
#endif